# Using System.Diagnostics.PerformanceCounter
$ppt = New-Object System.Diagnostics.PerformanceCounter
$ppt.CategoryName = 'Processor'
$ppt.CounterName = '% Processor Time'
$ppt.InstanceName = '_Total'
$ppt.NextValue()

$mab = New-Object System.Diagnostics.PerformanceCounter
$mab.CategoryName = 'Memory'
$mab.CounterName = 'Available MBytes'
$mab.NextValue()

# Using Get-Counter
$srv = 'WS16SQL'
$iname = 'SQLServer'
$counters = @(
    "\Processor(_Total)\% Processor Time",
    "\Memory\Available MBytes",
    "\Paging File(_Total)\% Usage",
    "\PhysicalDisk(_Total)\Avg. Disk sec/Read",
    "\PhysicalDisk(_Total)\Avg. Disk sec/Write",
    "\System\Processor Queue Length",
    "\$($iname):Access Methods\Forwarded Records/sec",
    "\$($iname):Access Methods\Page Splits/sec",
    "\$($iname):Buffer Manager\Buffer cache hit ratio",
    "\$($iname):Buffer Manager\Page life expectancy",
    "\$($iname):Databases(_Total)\Log Growths",
    "\$($iname):General Statistics\Processes blocked",
    "\$($iname):SQL Statistics\Batch Requests/sec",
    "\$($iname):SQL Statistics\SQL Compilations/sec",
    "\$($iname):SQL Statistics\SQL Re-Compilations/sec"
    )
      
# Get performance counter data
$ctr = Get-Counter -ComputerName $srv -Counter $counters -SampleInterval 10 -MaxSamples 3
$ctr | Get-Member

$ctr.Timestamp
$ctr.CounterSamples | select Path, CookedValue | Format-Table -AutoSize

$ctr | Export-Clixml -Path "c:\Work\WS16SQL_Counters.xml"

$newctr = Import-Clixml -Path "c:\Work\WS16SQL_Counters.xml"
$newctr.Timestamp
$newctr.CounterSamples | select Path, CookedValue | Format-Table -AutoSize
